/**
 * EasyBeans
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ISubstitutionEngine.java 5461 2010-03-26 16:01:19Z sauthieg $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.substitution;

/**
 * A {@code SubstitutionEngine} can substitute properties used in a
 * String by their values provided by a {@code IPropertyResolver}.
 * @author Guillaume Sauthier
 */
public interface ISubstitutionEngine {

    /**
     * Subsitute variables found in this String with their values.
     * @param variableValue chain to be evaluated
     * @return the given String with variable substituted with values
     * @throws IllegalArgumentException when the String cannot be parsed or
     *         when variables cannot be evaluated
     */
    String substitute(String variableValue);
}
